• <ins id="pjuwb"></ins>
    <blockquote id="pjuwb"><pre id="pjuwb"></pre></blockquote>
    <noscript id="pjuwb"></noscript>
          <sup id="pjuwb"><pre id="pjuwb"></pre></sup>
            <dd id="pjuwb"></dd>
            <abbr id="pjuwb"></abbr>

            coreBugZJ

            此 blog 已棄。

            生成全排列的非回溯方法(TopCoder SRM 591 DIV 2)

            問題來自 TopCoder SRM 591 DIV 2 的第二題:

            Problem Statement
               
            Let X and Y be two strings of equal length, consisting of uppercase English letters only. The two strings are called convertible if there is a permutation P of the English alphabet with the following property: if each character c in the string X is replaced by the character P(c), we obtain the string Y. (In other words, X and Y are convertible iff the following holds: whenever two letters of X are equal, the corresponding two letters of Y must be equal, and vice versa.)  For example, consider the string "ABCA". We can choose to replace each 'A' by a 'F', each 'B' by a 'B', and each 'C' by a 'G', obtaining the string "FBGF". Thus the strings "ABCA" and "FBGF" are convertible. The strings "ABCA" and "EFGH" are not convertible, because the two 'A's in the first string must correspond to the same letter in the second string. The strings "ABCA" and "EEEE" are not convertible, because different letters in the first string must correspond to different letters in the second string.  You are given two strings A and B of the same length. These strings only contain English letters from 'A' to 'I', inclusive. (That is, only the first 9 letters of the alphabet are used.)  You want to change A and B into two strings that are convertible. The only allowed change is to choose some indices (possibly none) and to remove the characters at those indices from each of the strings. (I.e., the removed characters must be at the same positions in both strings. For example, it is not allowed to only remove character 0 of A and character 3 of B.) For example, if A="ABAC", B="AHHA" and the chosen indices are 0 and 2, then the resulting strings will be "BC" and "HA". Our goal is to choose as few indices as possible, given that after the erasing we want to obtain two convertible strings. Compute and return the smallest possible number of chosen indices.
            Definition
               
            Class:
            ConvertibleStrings
            Method:
            leastRemovals
            Parameters:
            string, string
            Returns:
            int
            Method signature:
            int leastRemovals(string A, string B)
            (be sure your method is public)
               

            Constraints
            -
            A will contain between 1 and 50 characters, inclusive.
            -
            A and B will be of the same length.
            -
            A will contain characters from 'A' to 'I' only.
            -
            B will contain characters from 'A' to 'I' only.

            我的思路是窮舉A中字母與B中字母的對應關系,看哪種對應需要刪除的字母最少,這一最少值即是答案。
            窮舉對應關系,就是生成全排列。
            我生成全排列的方式是回溯。

            之后看其他人的代碼,發(fā)現(xiàn)一個由給定排列求出其下一個排列的函數(shù),于是學習一下,自己實現(xiàn)如下:

            // 生成下一字典序排列
            // 假設a中元素互不相同
            // 若已經是最后一個字典序排列,則返回0,否則返回1
            int next_permutation( int a[], int n ) {
                    
            int i, j;
                    
            for ( i = n-1; (0 < i) && (a[i-1> a[i]); --i ) {
                    }
                    
            if ( 0 >= i ) {
                            
            return 0;
                    }
                    
            for ( j = n-1; j >= i; --j ) {
                            
            if ( a[ j ] > a[ i-1 ] ) {
                                    
            int tmp = a[ i-1 ];
                                    a[ i
            -1 ] = a[ j ];
                                    a[ j ] 
            = tmp;
                                    j 
            = n - 1;
                                    
            while ( i < j ) {
                                            tmp 
            = a[ i ];
                                            a[ i ] 
            = a[ j ];
                                            a[ j ] 
            = tmp;
                                            
            ++i; --j;
                                    }
                                    
            break;
                            }
                    }
                    
            return 1;
            }

            還有人使用的是C++的 <algorithm> 中 next_permutation 函數(shù),功能一樣。


            posted on 2013-09-28 17:03 coreBugZJ 閱讀(895) 評論(0)  編輯 收藏 引用 所屬分類: ACMAlgorithm

            久久久久久久人妻无码中文字幕爆 | 亚洲国产成人精品女人久久久 | 久久精品视频一| 无码超乳爆乳中文字幕久久| 国产精品9999久久久久| 日本精品久久久久中文字幕| 久久久精品久久久久特色影视| 日韩AV毛片精品久久久| 久久久婷婷五月亚洲97号色| 婷婷久久综合九色综合98| 国内精品久久久久影院亚洲 | 国产91久久综合| 久久无码高潮喷水| 精品久久久久久久久久中文字幕| 综合久久精品色| 国产—久久香蕉国产线看观看| 国产aⅴ激情无码久久| 国产成人精品久久亚洲高清不卡| 亚洲国产美女精品久久久久∴| 久久国产免费| 国产午夜福利精品久久| 久久婷婷五月综合97色 | Xx性欧美肥妇精品久久久久久 | 狠狠色狠狠色综合久久| 久久中文精品无码中文字幕| 精品精品国产自在久久高清| 久久久精品国产sm调教网站| 久久精品免费一区二区| 色婷婷综合久久久久中文字幕| 精品国产一区二区三区久久久狼| 久久久久久精品成人免费图片| 精品久久久久久无码人妻热| 久久综合久久综合久久综合| 狠狠色噜噜狠狠狠狠狠色综合久久| 久久人做人爽一区二区三区| 一本久久综合亚洲鲁鲁五月天| 狠狠精品干练久久久无码中文字幕| 久久免费美女视频| 香蕉久久一区二区不卡无毒影院| 国产成人久久精品区一区二区| 九九久久自然熟的香蕉图片|